
/* ////////////////////////////////////
   
   Télécommande MINIMOD par code DTMF
   
   Utilise:
   Shield LCD, adaptateur TTL RS232 et câble null modem.

   Les commandes sont arbitrairement codées sur 3 codes DTMF
   Chaque commande doit commencer par #. Les 2 chiffres suivants
   doivent êtres différents. 
   Les ordres de ce programmes sont donnés à titre d'exemple

   Version 1.0
   F5MNA mai 2013  http://f5mna.free.fr
  
   /////////////////////////////////////
*/

//Port Serie
#include <SoftwareSerial.h> 
SoftwareSerial mySerial(1, 2); // RX, TX

//LCD
#include <LiquidCrystal.h>
// LCD RS pin to digital pin 8
// LCD Enable pin to digital pin 9
// LCD D4 pin to digital pin 4
// LCD D5 pin to digital pin 5
// LCD D6 pin to digital pin 6
// LCD D7 pin to digital pin 7
// LCD R/W pin to ground
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

//
int ConfDTMF = 3;  // Confirmation de réception d'un code DTMF Pin 3
int val = 0;       // Valeur lue.
//
int DTMFpin = A5;  // Enrée code DTMF R2R
int DTMFval = 0;   // Valeur Lue
int val_DTMF;      // Idem/10
String Touche,Touche1; // Gestion des codes
String Code[3] ; // Tableau pour 3 valeurs

int i;        // Décompte code
int Gain;     // Gestion du Gain Minimod
int CodOK;    // Validité commandes

void setup()  
 {
  i= -1; 
  CodOK = 0;
  pinMode (ConfDTMF,INPUT); // Reception d'un code DTMF
  ///
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
  lcd.print ("Controle MINIMOD");
  lcd.setCursor(0, 1);
  lcd.print ("F5MNA  Version 1");
  delay(2000);
  lcd.clear ();
  
  // Débit Data pour port Com du Minimod
  mySerial.begin(115200);
  
  //Paramétrage initiaux (reboot)  
       Gain = 5;
       mySerial.print ("35");                   
       mySerial.println (Gain); 
       mySerial.println("0"); 
       mySerial.println("3730");   
       mySerial.println("0");
       lcd.setCursor(0, 0);
       lcd.print ("  Ordre acquit  ");
       lcd.setCursor(0, 1);
       lcd.print (" initialisation ");
 }

void loop ()
  {
   Telecom();
  }
  
void Telecom ()
  {
   val = digitalRead (ConfDTMF);  //Arrivée d'un code DTMF 
   lcd.setCursor (0,0);
   if (val == HIGH)
   {lcd.setCursor (0,0);
    lcd.print ("*");
    lcd.setCursor (15,0);
    lcd.print ("*");}
    else
    {lcd.setCursor (0,0);
    lcd.print (" ");
    lcd.setCursor (15,0);
   lcd.print (" ");}
   
     
   val_DTMF = 0;                 //Valeur R2R correspondant au code 
   DTMFval = analogRead (DTMFpin);
   val_DTMF = int(DTMFval/10);
  
   Touche1 = Touche;
    
   //lcd.setCursor (4,1);
   
   switch (val_DTMF)
   {
   case 78:
   Touche = String ('0');
   break;
   
   case 2:
   Touche = String ('1');
   break;
   
   case 4:  
   Touche = String ('2');
   break;
  
   case 7:
   Touche = String ('3');
   break;
  
   case 9:
   Touche = String ('4');
   break;
   
   case 12:
   Touche = String ('5');
   break;
   
   case 15:
   Touche = String ('6');
   break;
   
   case 17:
   Touche = String ('7');
   break;
   
   case 68:
   Touche = String ('8');
   break;
   
   case 73:
   Touche = String ('9');
   break;
   
   case 83:
   Touche = String ('*');
   break;
   
   case 88:
   Touche = String ('#');
   break;   
 }
 // Création du code    
     if (Touche != Touche1) { i = i + 1;} //Avance à chaque appui différent (Anti rebond)
     if (Touche == String ('#')) { (i = 0);} // Doit commencer par '#'  
       Code[i] = Touche;
          if (i > 1) 
          {(i = 0);
          GesCodes(); } 
   }  
   
 // Gestion des Codes
 ///////////////////
 void GesCodes ()
 {
  lcd.setCursor (0,1);
 // Ordre 01 
       if ((Code[1] == String ('0')) and (Code[2] == String ('1')))  
       {
       Gain = 8;   
       mySerial.print ("35");                   
       mySerial.println (Gain); 
       mySerial.println("0");
       lcd.setCursor(0, 0);
       lcd.print ("  Ordre acquit  ");
       lcd.setCursor(0, 1);
       lcd.print ("     Gain 8     ");
       CodOK = 1;}
  // Ordre 02   
       if ((Code[1] == String ('0')) and (Code[2] == String ('2')))  
       {
       Gain = 5;   
       mySerial.print ("35");                   
       mySerial.println (Gain); 
       mySerial.println("0"); 
       lcd.setCursor(0, 0);
       lcd.print ("  Ordre acquit  ");
       lcd.setCursor(0, 1);
       lcd.print ("     Gain 5     ");       
       CodOK = 1;}
       
   // Ordre 03 
       if ((Code[1] == String ('0')) and (Code[2] == String ('3')))  
       {
        mySerial.println("3710");   
        mySerial.println("0");
        lcd.setCursor(0, 0);
        lcd.print ("  Ordre acquit  ");
        lcd.setCursor(0, 1);   
        lcd.print ("    FEC 1/2     "); 
        CodOK = 1;}
        
   // Ordre 04  
       if ((Code[1] == String ('0')) and (Code[2] == String ('4')))  
       {
       mySerial.println("3730");   
       mySerial.println("0");
       lcd.setCursor(0, 0);
       lcd.print ("  Ordre acquit  ");
       lcd.setCursor(0, 1);
       lcd.print ("    FEC 3/4     ");
       CodOK = 1;} 
       
   //Réinitialisation (Gain 5 et Fec 3/4)    
   // Ordre 05
         if ((Code[1] == String ('0')) and (Code[2] == String ('5')))  
       {
            Gain = 5;
            mySerial.print ("35");                   
            mySerial.println (Gain); 
            mySerial.println("0"); 
            mySerial.println("3730");   
            mySerial.println("0");
            lcd.setCursor(0, 0);
            lcd.print ("  Ordre acquit  ");
            lcd.setCursor(0, 1); 
            lcd.print (" initialisation ");
            CodOK = 1;}   
            
   // Ordres nuls   
        if (CodOK = 1)
        {lcd.print ("      nul       ");
         CodOK = 0; }  
  }     
 
